<?php
 
class myNifValidator extends sfValidator
{

  public function initialize($context, $parameters = null)
  {
    // initialize parent
    parent::initialize($context);
 
    // set defaults
    $this->setParameter('nif_error', 'Invalid input');
 
    $this->getParameterHolder()->add($parameters);
 
    return true;
  }
 
  public function execute(&$value, &$error)
  {
    $nif_param = $this->getParameter('nif');
    $nifi = $this->getContext()->getRequest()->getParameter($nif_param);
 
    $nif= new nif();
 
    // anonymous is not a real user
    if ($nif->f_nifcif_verify($nifi) == 1)
    {
      return true;
    }
    else
    {
      $error = $this->getParameter('nif_error');
      return false;
    }
   }
 }