<?php


abstract class BaseInscription extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $name;


	
	protected $surname;


	
	protected $nif;


	
	protected $email;


	
	protected $address;


	
	protected $postal_code;


	
	protected $city;


	
	protected $region;


	
	protected $country;


	
	protected $club;


	
	protected $price;


	
	protected $payed;


	
	protected $telephone;


	
	protected $created_at;


	
	protected $event_id;

	
	protected $aEvent;

	
	protected $collRunners;

	
	protected $lastRunnerCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getName()
	{

		return $this->name;
	}

	
	public function getSurname()
	{

		return $this->surname;
	}

	
	public function getNif()
	{

		return $this->nif;
	}

	
	public function getEmail()
	{

		return $this->email;
	}

	
	public function getAddress()
	{

		return $this->address;
	}

	
	public function getPostalCode()
	{

		return $this->postal_code;
	}

	
	public function getCity()
	{

		return $this->city;
	}

	
	public function getRegion()
	{

		return $this->region;
	}

	
	public function getCountry()
	{

		return $this->country;
	}

	
	public function getClub()
	{

		return $this->club;
	}

	
	public function getPrice()
	{

		return $this->price;
	}

	
	public function getPayed()
	{

		return $this->payed;
	}

	
	public function getTelephone()
	{

		return $this->telephone;
	}

	
	public function getCreatedAt($format = 'Y-m-d')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
						$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getEventId()
	{

		return $this->event_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = InscriptionPeer::ID;
		}

	} 
	
	public function setName($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->name !== $v) {
			$this->name = $v;
			$this->modifiedColumns[] = InscriptionPeer::NAME;
		}

	} 
	
	public function setSurname($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->surname !== $v) {
			$this->surname = $v;
			$this->modifiedColumns[] = InscriptionPeer::SURNAME;
		}

	} 
	
	public function setNif($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->nif !== $v) {
			$this->nif = $v;
			$this->modifiedColumns[] = InscriptionPeer::NIF;
		}

	} 
	
	public function setEmail($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->email !== $v) {
			$this->email = $v;
			$this->modifiedColumns[] = InscriptionPeer::EMAIL;
		}

	} 
	
	public function setAddress($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->address !== $v) {
			$this->address = $v;
			$this->modifiedColumns[] = InscriptionPeer::ADDRESS;
		}

	} 
	
	public function setPostalCode($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->postal_code !== $v) {
			$this->postal_code = $v;
			$this->modifiedColumns[] = InscriptionPeer::POSTAL_CODE;
		}

	} 
	
	public function setCity($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->city !== $v) {
			$this->city = $v;
			$this->modifiedColumns[] = InscriptionPeer::CITY;
		}

	} 
	
	public function setRegion($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->region !== $v) {
			$this->region = $v;
			$this->modifiedColumns[] = InscriptionPeer::REGION;
		}

	} 
	
	public function setCountry($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->country !== $v) {
			$this->country = $v;
			$this->modifiedColumns[] = InscriptionPeer::COUNTRY;
		}

	} 
	
	public function setClub($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->club !== $v) {
			$this->club = $v;
			$this->modifiedColumns[] = InscriptionPeer::CLUB;
		}

	} 
	
	public function setPrice($v)
	{

		if ($this->price !== $v) {
			$this->price = $v;
			$this->modifiedColumns[] = InscriptionPeer::PRICE;
		}

	} 
	
	public function setPayed($v)
	{

		if ($this->payed !== $v) {
			$this->payed = $v;
			$this->modifiedColumns[] = InscriptionPeer::PAYED;
		}

	} 
	
	public function setTelephone($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->telephone !== $v) {
			$this->telephone = $v;
			$this->modifiedColumns[] = InscriptionPeer::TELEPHONE;
		}

	} 
	
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = InscriptionPeer::CREATED_AT;
		}

	} 
	
	public function setEventId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->event_id !== $v) {
			$this->event_id = $v;
			$this->modifiedColumns[] = InscriptionPeer::EVENT_ID;
		}

		if ($this->aEvent !== null && $this->aEvent->getId() !== $v) {
			$this->aEvent = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->name = $rs->getString($startcol + 1);

			$this->surname = $rs->getString($startcol + 2);

			$this->nif = $rs->getString($startcol + 3);

			$this->email = $rs->getString($startcol + 4);

			$this->address = $rs->getString($startcol + 5);

			$this->postal_code = $rs->getString($startcol + 6);

			$this->city = $rs->getString($startcol + 7);

			$this->region = $rs->getString($startcol + 8);

			$this->country = $rs->getString($startcol + 9);

			$this->club = $rs->getString($startcol + 10);

			$this->price = $rs->getFloat($startcol + 11);

			$this->payed = $rs->getBoolean($startcol + 12);

			$this->telephone = $rs->getString($startcol + 13);

			$this->created_at = $rs->getDate($startcol + 14, null);

			$this->event_id = $rs->getInt($startcol + 15);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 16; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Inscription object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(InscriptionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			InscriptionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
    if ($this->isNew() && !$this->isColumnModified(InscriptionPeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(InscriptionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aEvent !== null) {
				if ($this->aEvent->isModified()) {
					$affectedRows += $this->aEvent->save($con);
				}
				$this->setEvent($this->aEvent);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = InscriptionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += InscriptionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collRunners !== null) {
				foreach($this->collRunners as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aEvent !== null) {
				if (!$this->aEvent->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aEvent->getValidationFailures());
				}
			}


			if (($retval = InscriptionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collRunners !== null) {
					foreach($this->collRunners as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = InscriptionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getName();
				break;
			case 2:
				return $this->getSurname();
				break;
			case 3:
				return $this->getNif();
				break;
			case 4:
				return $this->getEmail();
				break;
			case 5:
				return $this->getAddress();
				break;
			case 6:
				return $this->getPostalCode();
				break;
			case 7:
				return $this->getCity();
				break;
			case 8:
				return $this->getRegion();
				break;
			case 9:
				return $this->getCountry();
				break;
			case 10:
				return $this->getClub();
				break;
			case 11:
				return $this->getPrice();
				break;
			case 12:
				return $this->getPayed();
				break;
			case 13:
				return $this->getTelephone();
				break;
			case 14:
				return $this->getCreatedAt();
				break;
			case 15:
				return $this->getEventId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = InscriptionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getName(),
			$keys[2] => $this->getSurname(),
			$keys[3] => $this->getNif(),
			$keys[4] => $this->getEmail(),
			$keys[5] => $this->getAddress(),
			$keys[6] => $this->getPostalCode(),
			$keys[7] => $this->getCity(),
			$keys[8] => $this->getRegion(),
			$keys[9] => $this->getCountry(),
			$keys[10] => $this->getClub(),
			$keys[11] => $this->getPrice(),
			$keys[12] => $this->getPayed(),
			$keys[13] => $this->getTelephone(),
			$keys[14] => $this->getCreatedAt(),
			$keys[15] => $this->getEventId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = InscriptionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setName($value);
				break;
			case 2:
				$this->setSurname($value);
				break;
			case 3:
				$this->setNif($value);
				break;
			case 4:
				$this->setEmail($value);
				break;
			case 5:
				$this->setAddress($value);
				break;
			case 6:
				$this->setPostalCode($value);
				break;
			case 7:
				$this->setCity($value);
				break;
			case 8:
				$this->setRegion($value);
				break;
			case 9:
				$this->setCountry($value);
				break;
			case 10:
				$this->setClub($value);
				break;
			case 11:
				$this->setPrice($value);
				break;
			case 12:
				$this->setPayed($value);
				break;
			case 13:
				$this->setTelephone($value);
				break;
			case 14:
				$this->setCreatedAt($value);
				break;
			case 15:
				$this->setEventId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = InscriptionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setName($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setSurname($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setNif($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setEmail($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setAddress($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setPostalCode($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setCity($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setRegion($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setCountry($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setClub($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setPrice($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setPayed($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setTelephone($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setCreatedAt($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setEventId($arr[$keys[15]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(InscriptionPeer::DATABASE_NAME);

		if ($this->isColumnModified(InscriptionPeer::ID)) $criteria->add(InscriptionPeer::ID, $this->id);
		if ($this->isColumnModified(InscriptionPeer::NAME)) $criteria->add(InscriptionPeer::NAME, $this->name);
		if ($this->isColumnModified(InscriptionPeer::SURNAME)) $criteria->add(InscriptionPeer::SURNAME, $this->surname);
		if ($this->isColumnModified(InscriptionPeer::NIF)) $criteria->add(InscriptionPeer::NIF, $this->nif);
		if ($this->isColumnModified(InscriptionPeer::EMAIL)) $criteria->add(InscriptionPeer::EMAIL, $this->email);
		if ($this->isColumnModified(InscriptionPeer::ADDRESS)) $criteria->add(InscriptionPeer::ADDRESS, $this->address);
		if ($this->isColumnModified(InscriptionPeer::POSTAL_CODE)) $criteria->add(InscriptionPeer::POSTAL_CODE, $this->postal_code);
		if ($this->isColumnModified(InscriptionPeer::CITY)) $criteria->add(InscriptionPeer::CITY, $this->city);
		if ($this->isColumnModified(InscriptionPeer::REGION)) $criteria->add(InscriptionPeer::REGION, $this->region);
		if ($this->isColumnModified(InscriptionPeer::COUNTRY)) $criteria->add(InscriptionPeer::COUNTRY, $this->country);
		if ($this->isColumnModified(InscriptionPeer::CLUB)) $criteria->add(InscriptionPeer::CLUB, $this->club);
		if ($this->isColumnModified(InscriptionPeer::PRICE)) $criteria->add(InscriptionPeer::PRICE, $this->price);
		if ($this->isColumnModified(InscriptionPeer::PAYED)) $criteria->add(InscriptionPeer::PAYED, $this->payed);
		if ($this->isColumnModified(InscriptionPeer::TELEPHONE)) $criteria->add(InscriptionPeer::TELEPHONE, $this->telephone);
		if ($this->isColumnModified(InscriptionPeer::CREATED_AT)) $criteria->add(InscriptionPeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(InscriptionPeer::EVENT_ID)) $criteria->add(InscriptionPeer::EVENT_ID, $this->event_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(InscriptionPeer::DATABASE_NAME);

		$criteria->add(InscriptionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setName($this->name);

		$copyObj->setSurname($this->surname);

		$copyObj->setNif($this->nif);

		$copyObj->setEmail($this->email);

		$copyObj->setAddress($this->address);

		$copyObj->setPostalCode($this->postal_code);

		$copyObj->setCity($this->city);

		$copyObj->setRegion($this->region);

		$copyObj->setCountry($this->country);

		$copyObj->setClub($this->club);

		$copyObj->setPrice($this->price);

		$copyObj->setPayed($this->payed);

		$copyObj->setTelephone($this->telephone);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setEventId($this->event_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getRunners() as $relObj) {
				$copyObj->addRunner($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new InscriptionPeer();
		}
		return self::$peer;
	}

	
	public function setEvent($v)
	{


		if ($v === null) {
			$this->setEventId(NULL);
		} else {
			$this->setEventId($v->getId());
		}


		$this->aEvent = $v;
	}


	
	public function getEvent($con = null)
	{
		if ($this->aEvent === null && ($this->event_id !== null)) {
						include_once 'lib/model/om/BaseEventPeer.php';

			$this->aEvent = EventPeer::retrieveByPK($this->event_id, $con);

			
		}
		return $this->aEvent;
	}

	
	public function initRunners()
	{
		if ($this->collRunners === null) {
			$this->collRunners = array();
		}
	}

	
	public function getRunners($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
			   $this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				$this->collRunners = RunnerPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

				RunnerPeer::addSelectColumns($criteria);
				if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
					$this->collRunners = RunnerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastRunnerCriteria = $criteria;
		return $this->collRunners;
	}

	
	public function countRunners($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

		return RunnerPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addRunner(Runner $l)
	{
		$this->collRunners[] = $l;
		$l->setInscription($this);
	}


	
	public function getRunnersJoinSize($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinSize($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinSize($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}


	
	public function getRunnersJoinCategory($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseRunnerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collRunners === null) {
			if ($this->isNew()) {
				$this->collRunners = array();
			} else {

				$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

				$this->collRunners = RunnerPeer::doSelectJoinCategory($criteria, $con);
			}
		} else {
									
			$criteria->add(RunnerPeer::INSCRIPTION_ID, $this->getId());

			if (!isset($this->lastRunnerCriteria) || !$this->lastRunnerCriteria->equals($criteria)) {
				$this->collRunners = RunnerPeer::doSelectJoinCategory($criteria, $con);
			}
		}
		$this->lastRunnerCriteria = $criteria;

		return $this->collRunners;
	}

} 