<?php



class PictureMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.PictureMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('picture');
		$tMap->setPhpName('Picture');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('NAME', 'Name', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('MIME', 'Mime', 'string', CreoleTypes::VARCHAR, false, 255);

		$tMap->addColumn('SIZE', 'Size', 'int', CreoleTypes::INTEGER, false, null);

		$tMap->addColumn('DATA', 'Data', 'string', CreoleTypes::BLOB, false, null);

	} 
} 